<?php 
/**
 * $ModDesc
 * 
 * @version   $Id: $file.php $Revision
 * @package   modules
 * @subpackage  $Subpackage.
 * @copyright Copyright (C) www.joomdonation.com .All rights reserved.
 * @license   GNU General Public License version 2
 */
 
// no direct access
defined('_JEXEC') or die;
define('DS',DIRECTORY_SEPARATOR);
if( !defined('PhpThumbFactoryLoaded') ) {
	require_once dirname(__FILE__).DS.'libs'.DS.'phpthumb/ThumbLib.inc.php';
	define('PhpThumbFactoryLoaded',1);
}
/**
 * modLofArticlesSlideShowHelper Class 
 */
abstract class modOsPropertySlideShowHelper {
	
  /**
   * get list of articles follow conditions user selected
   */ 
  public static function getList(&$params)
  {
  	define('DS',DIRECTORY_SEPARATOR);
  	jimport('joomla.filesystem.folder');
  	$enableImageLink = $params->get( 'enable_image_link' , 0);
	// navigator setting 
	$navEnableThumbnail     = $params->get( 'enable_thumbnail', 1 );
	$navEnableTitle         = $params->get( 'enable_navtitle', 1 );
	$navEnableDate          = $params->get( 'enable_navdate', 1 );
	$navEnableCate          = $params->get( 'enable_navcate', 1 );
	$navEnableAgent         = $params->get( 'enable_agent', 1 );
	$enable_property_link   = $params->get( 'enable_property_link', 1 );
    $formatter           = $params->get( 'style_displaying', 'title' );
    $titleMaxChars       = $params->get( 'title_max_chars', '100' );
    $descriptionMaxChars = $params->get( 'description_max_chars', 100 );
    $thumbWidth    = (int)$params->get( 'thumbnail_width', 60 );
    $thumbHeight   = (int)$params->get( 'thumbnail_height', 60 );
    $imageHeight   = (int)$params->get( 'main_height', 300 ) ;
    $imageWidth    = (int)$params->get( 'main_width', 650 ) ;
    $isThumb       = $params->get( 'auto_renderthumb',1);
    $ordering      = $params->get('ordering', 'created-asc');
    $replacer      = $params->get('replacer','...'); 
    $limitDescriptionBy = $params->get('limit_description_by','char');
	$isAutoStripsTag = $params->get('auto_strip_tags','1');
    // Get the dbo
    $db = JFactory::getDbo();
	
	if( !is_dir(JPATH_SITE.DS.'cache'.DS.'ospropertyslideshow') ){
		JFolder::create( JPATH_SITE.DS.'cache'.DS.'ospropertyslideshow' );
	}
    
    include_once(JPATH_ROOT.DS."components".DS."com_osproperty".DS."helpers".DS."common.php");
    
 	$user = JFactory::getUser();
    
    $source = trim($params->get('source', 'properties'));
 
    if($source == "properties"){
    	$ids = $params->get('properties_ids','');
    	if($ids != ""){
    		//$idArr = explode(",",$ids);
    		$query = "SELECT a.*,b.category_name,c.type_name,d.country_name,e.state_name,q.name as agent_name FROM #__osrs_properties AS a "
    				." INNER JOIN #__osrs_categories AS b ON b.id = a.category_id"
    				." INNER JOIN #__osrs_types AS c ON c.id = a.pro_type"
    				." INNER JOIN #__osrs_countries AS d ON  d.id = a.country"
    				." INNER JOIN #__osrs_states AS e ON e.id = a.state"
    				." INNER JOIN #__osrs_agents AS q ON q.id = a.agent_id"
    				." WHERE a.id IN ($ids)";
    		$db->setQuery($query);
    		$items = $db->loadObjectList();
    	}
    }else{
    	$categories_ids = $params->get('categories_ids','');
    	$types_ids 		= $params->get('types_ids','');
    	$cities_ids 	= $params->get('cities_ids','');
    	$states_ids		= $params->get('states_ids','');
    	$countries_ids	= $params->get('countries_ids','');
    	$show_featured	= $params->get('show_featured','0');
    	$limit_items 	= $params->get('limit_items','5');
    	$ordering		= $params->get('ordering','');
    	
    	$query = "SELECT a.*,b.category_name,c.type_name,d.country_name,e.state_name,q.name as agent_name FROM #__osrs_properties AS a "
			." INNER JOIN #__osrs_categories AS b ON b.id = a.category_id"
			." INNER JOIN #__osrs_types AS c ON c.id = a.pro_type"
			." INNER JOIN #__osrs_countries AS d ON  d.id = a.country"
			." INNER JOIN #__osrs_states AS e ON e.id = a.state"
			." INNER JOIN #__osrs_agents AS q ON q.id = a.agent_id"
			." WHERE a.approved = '1' ";
		if($categories_ids != ""){
			$query .= " AND a.category_id in ($categories_ids)";
		}
		if($types_ids != ""){
			$query .= " AND a.pro_type in ($types_ids)";
		}
		if($cities_ids != ""){
			$query .= " AND a.city in ($cities_ids)";
		}
		if($states_ids != ""){
			$query .= " AND a.state in ($states_ids)";
		}
		if($countries_ids != ""){
			$query .= " AND a.country in ($countries_ids)";
		}
		if($show_featured == 1){
			$query .= " AND a.isFeatured = '1'";
		}
		
		switch ($ordering){
			case "id-asc":
				$query .= " ORDER BY a.id";
			break;
			case "id-desc":
				$query .= " ORDER BY a.id DESC";
			break;
			case "hits-asc":
				$query .= " ORDER BY a.hits";
			break;
			case "hit-desc":
				$query .= " ORDER BY a.hits DESC";
			break;
			case "rand-":
				$query .= " ORDER BY rand()";
			break;
			case "created-desc":
				$query .= " ORDER BY a.created";
			break;
			case "created-asc":
				$query .= " ORDER BY a.created DESC";
			break;
		}
		
		if(intval($limit_items) > 0){
			$query .= " LIMIT ".intval($limit_items);
		}
		
		$db->setQuery($query);
		//echo $db->getQuery();
		$items = $db->loadObjectList();
    }
    
    foreach ($items AS &$item) {
      $db->setQuery("Select image from #__osrs_photos where pro_id = '$item->id' order by ordering");
      $photo = $db->loadResult();
      if ($item->access == 0 || ($item->access == 1 && intval($user->id) > 0)){
        // We know that user has the privilege to view the article
        $item->link = JRoute::_("index.php?option=com_osproperty&task=property_details&id=".$item->id."&Itemid=".JRequest::getVar('Itemid'));
      }
      else {
        $item->link = JRoute::_('index.php?option=com_user&view=login');
      }
      
      $price = "<b>".$item->type_name."</b>";
      if($item->price_call == 0){
			if($item->price > 0){
				$price .= " &gt;&gt; <span>".HelperOspropertyCommon::loadCurrency($item->curr)." ".HelperOspropertyCommon::showPrice($item->price);
				if($row->rent_time != ""){
					$price .= "/".$row->rent_time;
				}
				$price .= "</span>";
			}
	  }
	  elseif($item->price_call == 1){
		  $price .= " &gt;&gt; ".JText::_('CALL_FOR_PRICE');
	  }
      $item->date = $price;
      
      
      if($item->show_address == 1){
      	  /*
      	  $address = $item->address;
      	  if($item->postcode != ""){
      	  	$address .= ", ".$item->postcode;
      	  }
      	  if($item->region != ""){
      	  	$address .= ", ".$item->region;
      	  }
      	  if($item->city > 0){
      	  	$address .= ", ".HelperOspropertyCommon::loadCityName($item->city);
      	  }
      	  if($item->state_name != ""){
      	  	$address .= ", ".$item->state_name;
      	  }
      	  if($item->country_name != ""){
      	  	$address .= ", ".$item->country_name;
      	  }
      	  */
      	  $address = OSPHelper::generateAddress($item);
      }else{
      	  $address = "";
      }
      
      $item = self::parseImages( $item );
      
      $medium_image = JURI::root()."images/osproperty/properties/".$photo;
	  if(file_exists(JPATH_ROOT.DS."images/osproperty/properties/".$photo)){
	      $mainImage = self::renderThumb($medium_image, $imageWidth, $imageHeight, $item->pro_name, false ) ;
	  }
      $item->mainImage = $mainImage;
      
	  $thumb_image = JURI::root()."images/osproperty/properties/thumb/".$photo;
	  if(file_exists(JPATH_ROOT.DS."images/osproperty/properties/thumb/".$photo)){
		$thumbImage = self::renderThumb($thumb_image, $thumbWidth, $thumbHeight, $item->pro_name, true ) ;
	  }
      $item->thumbnail = $thumbImage;
      
      $item->fulltext = "";
      $item->introtext   = "";
      $title = "";
      if($item->ref != ""){
      	$title  .= $item->ref.", ";
      }
      $title  .= $item->pro_name;
      $item->subtitle    = $title;
      
      ob_start();
      ?>
      <h3 style="padding:0px;margin:0px;">
      	<a href="<?php echo JRoute::_("index.php?option=com_osproperty&task=property_details&id=$item->id&Itemid=".Jrequest::getVar('Itemid'))?>" style="text-decoration:none;">
      		<?php 
      		if($item->ref != ""){
      			?>
      			<?php echo $item->ref?>,&nbsp;
      			<?php	
      		}
      		?>
      		<?php echo $item->pro_name?>
      	</a>
      </h3>
      <BR />
      <?php
      if($address != ""){
      	  echo $address."<BR />";
      }
      if( $navEnableCate == 1){
	      if($item->category_name != ""){
	      	$cat_link = JRoute::_('index.php?option=com_osproperty&task=category_details&id='.$item->category_id.'&Itemid='.JRequest::getVar('Itemid'));
	      	echo JText::_('CATEGORY').": <a href='$cat_link'>".$item->category_name."</a><BR />";
	      }
      }
      if($navEnableAgent == 1){
	      if($item->agent_name != ""){
	      	$agent_link = JRoute::_('index.php?option=com_osproperty&task=agent_info&id='.$item->agent_id.'&Itemid='.JRequest::getVar('Itemid'));
	      	echo JText::_('AGENT').": <a href='$agent_link'>".$item->agent_name."</a><BR />";
	      }
      }
      ?>
      <?php
      $desc = ob_get_contents();
      ob_end_clean();
      if($enable_property_link  == 1){
      	  $desc .= "<BR /><a href='$item->link'>".JText::_('VIEW_PROPERTY_DETAILS')."</a>";
      }
      
      $item->description = $desc;
      
    }
	
    return $items;
  }
		
	/**
	 * parser a custom tag in the content of article to get the image setting.
	 * 
	 * @param string $text
	 * @return array if maching.
	 */
	public static function parserCustomTag( $text ){ 
		if( preg_match("#{lofimg(.*)}#s", $text, $matches, PREG_OFFSET_CAPTURE) ){ 
			return $matches;
		}	
		return null;
	}
	
	/**
	 *  check the folder is existed, if not make a directory and set permission is 755
	 *
	 * @param array $path
	 * @access public,
	 * @return boolean.
	 */
	public static function renderThumb( $path, $width=100, $height=100, $title='', $isThumb=true ){
		
		if( $isThumb ){
			$path = str_replace( JURI::base(), '', $path );
			$imagSource = JPATH_SITE.DS. str_replace( '/', DS,  $path );
			if( file_exists($imagSource)  ) {
				$tmp = explode("/", $path);
				$imageName = $width."x".$height."-".$tmp[count($tmp)-1];
				$thumbPath = JPATH_SITE.DS.'cache'.DS.'ospropertyslideshow'.DS.$imageName;
				if( !file_exists($thumbPath) ) {
					$thumb = PhpThumbFactory::create( $imagSource  );  	
					$thumb->adaptiveResize( $width, $height);
					 
					$thumb->save( $thumbPath  ); 
				}
				$path = JURI::base().'cache/ospropertyslideshow/'.$imageName;
			} 
		}
		
		return '<img src="'.$path.'" title="'.$title.'" width="'.$width.'" alt="'.$title.'" >';;
	}
 
	
	/**
	 * get parameters from configuration string.
	 *
	 * @param string $string;
	 * @return array.
	 */
	public static function parseParams( $string ) {
		$string = html_entity_decode($string, ENT_QUOTES);
		$regex = "/\s*([^=\s]+)\s*=\s*('([^']*)'|\"([^\"]*)\"|([^\s]*))/";
		 $params = null;
		 if(preg_match_all($regex, $string, $matches) ){
				for ($i=0;$i<count($matches[1]);$i++){ 
				  $key 	 = $matches[1][$i];
				  $value = $matches[3][$i]?$matches[3][$i]:($matches[4][$i]?$matches[4][$i]:$matches[5][$i]);
				  $params[$key] = $value;
				}
		  }
		  return $params;
	}
	
	/**
	 * parser a image in the content of article.
	 *
	 * @param.
	 * @return
	 */
	public static function parseImages( $row ){
		
		$row->images = json_decode( $row->images );
		if( isset($row->images->image_fulltext) && isset($row->images->image_intro) ){
			$row->thumbnail = $row->images->image_intro;
			$row->mainImage = $row->images->image_fulltext;	
			if( empty($row->images->image_fulltext) ){
				$row->mainImage = $row->images->image_intro;
			} 
			if( empty($row->images->image_intro) ){
				$row->thumbnail = $row->images->image_fulltext;	
			}
		}
		if( empty($row->thumbnail) &&   empty($row->mainImage) ){
			$text =  $row->introtext;
			$regex = "/\<img.+src\s*=\s*\"([^\"]*)\"[^\>]*\>/";
			preg_match ($regex, $text, $matches); 
			$images = (count($matches)) ? $matches : array();
			if (count($images)){
				$row->mainImage = $images[1];
				$row->thumbnail = $images[1];
			} else {
				$row->thumbnail = '';
				$row->mainImage = '';	
			}
		}
		
		return $row;
	}
	
	/**
	 * load css - javascript file.
	 * 
	 * @param JParameter $params;
	 * @param JModule $module
	 * @return void.
	 */
	public static function loadMediaFiles( $params, $module ){
		$document = &JFactory::getDocument();
		$document->addScript( JURI::root(true). '/modules/'.$module->module.'/assets/jscript.js' );	
		$document->addStyleSheet( JURI::root(true). '/modules/'.$module->module.'/assets/jstyle.css' );	
	}
	
	/**
	 * get a subtring with the max length setting.
	 * 
	 * @param string $text;
	 * @param int $length limit characters showing;
	 * @param string $replacer;
	 * @return tring;
	 */
	public static function substring( $text, $length = 100, $replacer='...', $isAutoStripsTag = true ){
		$string =  $isAutoStripsTag?  strip_tags( $text ):$text;
		return JString::strlen( $string ) > $length ?  JHtml::_('string.truncate', $string, $length ): $string;
	}
}
?>